install.sh 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512
  1. #!/bin/sh
  2. #
  3. # This script should be run via curl:
  4. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  5. # or via wget:
  6. # sh -c "$(wget -qO- https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  7. # or via fetch:
  8. # sh -c "$(fetch -o - https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)"
  9. #
  10. # As an alternative, you can first download the install script and run it afterwards:
  11. # wget https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh
  12. # sh install.sh
  13. #
  14. # You can tweak the install behavior by setting variables when running the script. For
  15. # example, to change the path to the Oh My Zsh repository:
  16. # ZSH=~/.zsh sh install.sh
  17. #
  18. # Respects the following environment variables:
  19. # ZSH - path to the Oh My Zsh repository folder (default: $HOME/.oh-my-zsh)
  20. # REPO - name of the GitHub repo to install from (default: ohmyzsh/ohmyzsh)
  21. # REMOTE - full remote URL of the git repo to install (default: GitHub via HTTPS)
  22. # BRANCH - branch to check out immediately after install (default: master)
  23. #
  24. # Other options:
  25. # CHSH - 'no' means the installer will not change the default shell (default: yes)
  26. # RUNZSH - 'no' means the installer will not run zsh after the install (default: yes)
  27. # KEEP_ZSHRC - 'yes' means the installer will not replace an existing .zshrc (default: no)
  28. #
  29. # You can also pass some arguments to the install script to set some these options:
  30. # --skip-chsh: has the same behavior as setting CHSH to 'no'
  31. # --unattended: sets both CHSH and RUNZSH to 'no'
  32. # --keep-zshrc: sets KEEP_ZSHRC to 'yes'
  33. # For example:
  34. # sh install.sh --unattended
  35. # or:
  36. # sh -c "$(curl -fsSL https://raw.githubusercontent.com/ohmyzsh/ohmyzsh/master/tools/install.sh)" "" --unattended
  37. #
  38. set -e
  39. # Make sure important variables exist if not already defined
  40. #
  41. # $USER is defined by login(1) which is not always executed (e.g. containers)
  42. # POSIX: https://pubs.opengroup.org/onlinepubs/009695299/utilities/id.html
  43. USER=${USER:-$(id -u -n)}
  44. # $HOME is defined at the time of login, but it could be unset. If it is unset,
  45. # a tilde by itself (~) will not be expanded to the current user's home directory.
  46. # POSIX: https://pubs.opengroup.org/onlinepubs/009696899/basedefs/xbd_chap08.html#tag_08_03
  47. HOME="${HOME:-$(getent passwd $USER 2>/dev/null | cut -d: -f6)}"
  48. # macOS does not have getent, but this works even if $HOME is unset
  49. HOME="${HOME:-$(eval echo ~$USER)}"
  50. # Track if $ZSH was provided
  51. custom_zsh=${ZSH:+yes}
  52. # Default settings
  53. ZSH="${ZSH:-$HOME/.oh-my-zsh}"
  54. REPO=${REPO:-ohmyzsh/ohmyzsh}
  55. REMOTE=${REMOTE:-https://github.com/${REPO}.git}
  56. BRANCH=${BRANCH:-master}
  57. # Other options
  58. CHSH=${CHSH:-yes}
  59. RUNZSH=${RUNZSH:-yes}
  60. KEEP_ZSHRC=${KEEP_ZSHRC:-no}
  61. command_exists() {
  62. command -v "$@" >/dev/null 2>&1
  63. }
  64. user_can_sudo() {
  65. # Check if sudo is installed
  66. command_exists sudo || return 1
  67. # The following command has 3 parts:
  68. #
  69. # 1. Run `sudo` with `-v`. Does the following:
  70. # • with privilege: asks for a password immediately.
  71. # • without privilege: exits with error code 1 and prints the message:
  72. # Sorry, user <username> may not run sudo on <hostname>
  73. #
  74. # 2. Pass `-n` to `sudo` to tell it to not ask for a password. If the
  75. # password is not required, the command will finish with exit code 0.
  76. # If one is required, sudo will exit with error code 1 and print the
  77. # message:
  78. # sudo: a password is required
  79. #
  80. # 3. Check for the words "may not run sudo" in the output to really tell
  81. # whether the user has privileges or not. For that we have to make sure
  82. # to run `sudo` in the default locale (with `LANG=`) so that the message
  83. # stays consistent regardless of the user's locale.
  84. #
  85. ! LANG= sudo -n -v 2>&1 | grep -q "may not run sudo"
  86. }
  87. # The [ -t 1 ] check only works when the function is not called from
  88. # a subshell (like in `$(...)` or `(...)`, so this hack redefines the
  89. # function at the top level to always return false when stdout is not
  90. # a tty.
  91. if [ -t 1 ]; then
  92. is_tty() {
  93. true
  94. }
  95. else
  96. is_tty() {
  97. false
  98. }
  99. fi
  100. # This function uses the logic from supports-hyperlinks[1][2], which is
  101. # made by Kat Marchán (@zkat) and licensed under the Apache License 2.0.
  102. # [1] https://github.com/zkat/supports-hyperlinks
  103. # [2] https://crates.io/crates/supports-hyperlinks
  104. #
  105. # Copyright (c) 2021 Kat Marchán
  106. #
  107. # Licensed under the Apache License, Version 2.0 (the "License");
  108. # you may not use this file except in compliance with the License.
  109. # You may obtain a copy of the License at
  110. #
  111. # http://www.apache.org/licenses/LICENSE-2.0
  112. #
  113. # Unless required by applicable law or agreed to in writing, software
  114. # distributed under the License is distributed on an "AS IS" BASIS,
  115. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  116. # See the License for the specific language governing permissions and
  117. # limitations under the License.
  118. supports_hyperlinks() {
  119. # $FORCE_HYPERLINK must be set and be non-zero (this acts as a logic bypass)
  120. if [ -n "$FORCE_HYPERLINK" ]; then
  121. [ "$FORCE_HYPERLINK" != 0 ]
  122. return $?
  123. fi
  124. # If stdout is not a tty, it doesn't support hyperlinks
  125. is_tty || return 1
  126. # DomTerm terminal emulator (domterm.org)
  127. if [ -n "$DOMTERM" ]; then
  128. return 0
  129. fi
  130. # VTE-based terminals above v0.50 (Gnome Terminal, Guake, ROXTerm, etc)
  131. if [ -n "$VTE_VERSION" ]; then
  132. [ $VTE_VERSION -ge 5000 ]
  133. return $?
  134. fi
  135. # If $TERM_PROGRAM is set, these terminals support hyperlinks
  136. case "$TERM_PROGRAM" in
  137. Hyper|iTerm.app|terminology|WezTerm) return 0 ;;
  138. esac
  139. # kitty supports hyperlinks
  140. if [ "$TERM" = xterm-kitty ]; then
  141. return 0
  142. fi
  143. # Windows Terminal or Konsole also support hyperlinks
  144. if [ -n "$WT_SESSION" ] || [ -n "$KONSOLE_VERSION" ]; then
  145. return 0
  146. fi
  147. return 1
  148. }
  149. # Adapted from code and information by Anton Kochkov (@XVilka)
  150. # Source: https://gist.github.com/XVilka/8346728
  151. supports_truecolor() {
  152. case "$COLORTERM" in
  153. truecolor|24bit) return 0 ;;
  154. esac
  155. case "$TERM" in
  156. iterm |\
  157. tmux-truecolor |\
  158. linux-truecolor |\
  159. xterm-truecolor |\
  160. screen-truecolor) return 0 ;;
  161. esac
  162. return 1
  163. }
  164. fmt_link() {
  165. # $1: text, $2: url, $3: fallback mode
  166. if supports_hyperlinks; then
  167. printf '\033]8;;%s\a%s\033]8;;\a\n' "$2" "$1"
  168. return
  169. fi
  170. case "$3" in
  171. --text) printf '%s\n' "$1" ;;
  172. --url|*) fmt_underline "$2" ;;
  173. esac
  174. }
  175. fmt_underline() {
  176. is_tty && printf '\033[4m%s\033[24m\n' "$*" || printf '%s\n' "$*"
  177. }
  178. # shellcheck disable=SC2016 # backtick in single-quote
  179. fmt_code() {
  180. is_tty && printf '`\033[2m%s\033[22m`\n' "$*" || printf '`%s`\n' "$*"
  181. }
  182. fmt_error() {
  183. printf '%sError: %s%s\n' "${FMT_BOLD}${FMT_RED}" "$*" "$FMT_RESET" >&2
  184. }
  185. setup_color() {
  186. # Only use colors if connected to a terminal
  187. if ! is_tty; then
  188. FMT_RAINBOW=""
  189. FMT_RED=""
  190. FMT_GREEN=""
  191. FMT_YELLOW=""
  192. FMT_BLUE=""
  193. FMT_BOLD=""
  194. FMT_RESET=""
  195. return
  196. fi
  197. if supports_truecolor; then
  198. FMT_RAINBOW="
  199. $(printf '\033[38;2;255;0;0m')
  200. $(printf '\033[38;2;255;97;0m')
  201. $(printf '\033[38;2;247;255;0m')
  202. $(printf '\033[38;2;0;255;30m')
  203. $(printf '\033[38;2;77;0;255m')
  204. $(printf '\033[38;2;168;0;255m')
  205. $(printf '\033[38;2;245;0;172m')
  206. "
  207. else
  208. FMT_RAINBOW="
  209. $(printf '\033[38;5;196m')
  210. $(printf '\033[38;5;202m')
  211. $(printf '\033[38;5;226m')
  212. $(printf '\033[38;5;082m')
  213. $(printf '\033[38;5;021m')
  214. $(printf '\033[38;5;093m')
  215. $(printf '\033[38;5;163m')
  216. "
  217. fi
  218. FMT_RED=$(printf '\033[31m')
  219. FMT_GREEN=$(printf '\033[32m')
  220. FMT_YELLOW=$(printf '\033[33m')
  221. FMT_BLUE=$(printf '\033[34m')
  222. FMT_BOLD=$(printf '\033[1m')
  223. FMT_RESET=$(printf '\033[0m')
  224. }
  225. setup_ohmyzsh() {
  226. # Prevent the cloned repository from having insecure permissions. Failing to do
  227. # so causes compinit() calls to fail with "command not found: compdef" errors
  228. # for users with insecure umasks (e.g., "002", allowing group writability). Note
  229. # that this will be ignored under Cygwin by default, as Windows ACLs take
  230. # precedence over umasks except for filesystems mounted with option "noacl".
  231. umask g-w,o-w
  232. echo "${FMT_BLUE}Cloning Oh My Zsh...${FMT_RESET}"
  233. command_exists git || {
  234. fmt_error "git is not installed"
  235. exit 1
  236. }
  237. ostype=$(uname)
  238. if [ -z "${ostype%CYGWIN*}" ] && git --version | grep -q msysgit; then
  239. fmt_error "Windows/MSYS Git is not supported on Cygwin"
  240. fmt_error "Make sure the Cygwin git package is installed and is first on the \$PATH"
  241. exit 1
  242. fi
  243. # Manual clone with git config options to support git < v1.7.2
  244. git init --quiet "$ZSH" && cd "$ZSH" \
  245. && git config core.eol lf \
  246. && git config core.autocrlf false \
  247. && git config fsck.zeroPaddedFilemode ignore \
  248. && git config fetch.fsck.zeroPaddedFilemode ignore \
  249. && git config receive.fsck.zeroPaddedFilemode ignore \
  250. && git config oh-my-zsh.remote origin \
  251. && git config oh-my-zsh.branch "$BRANCH" \
  252. && git remote add origin "$REMOTE" \
  253. && git fetch --depth=1 origin \
  254. && git checkout -b "$BRANCH" "origin/$BRANCH" || {
  255. [ ! -d "$ZSH" ] || rm -rf "$ZSH" 2>/dev/null
  256. fmt_error "git clone of oh-my-zsh repo failed"
  257. exit 1
  258. }
  259. echo
  260. }
  261. setup_zshrc() {
  262. # Keep most recent old .zshrc at .zshrc.pre-oh-my-zsh, and older ones
  263. # with datestamp of installation that moved them aside, so we never actually
  264. # destroy a user's original zshrc
  265. echo "${FMT_BLUE}Looking for an existing zsh config...${FMT_RESET}"
  266. # Must use this exact name so uninstall.sh can find it
  267. OLD_ZSHRC=~/.zshrc.pre-oh-my-zsh
  268. if [ -f ~/.zshrc ] || [ -h ~/.zshrc ]; then
  269. # Skip this if the user doesn't want to replace an existing .zshrc
  270. if [ "$KEEP_ZSHRC" = yes ]; then
  271. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Keeping...${FMT_RESET}"
  272. return
  273. fi
  274. if [ -e "$OLD_ZSHRC" ]; then
  275. OLD_OLD_ZSHRC="${OLD_ZSHRC}-$(date +%Y-%m-%d_%H-%M-%S)"
  276. if [ -e "$OLD_OLD_ZSHRC" ]; then
  277. fmt_error "$OLD_OLD_ZSHRC exists. Can't back up ${OLD_ZSHRC}"
  278. fmt_error "re-run the installer again in a couple of seconds"
  279. exit 1
  280. fi
  281. mv "$OLD_ZSHRC" "${OLD_OLD_ZSHRC}"
  282. echo "${FMT_YELLOW}Found old ~/.zshrc.pre-oh-my-zsh." \
  283. "${FMT_GREEN}Backing up to ${OLD_OLD_ZSHRC}${FMT_RESET}"
  284. fi
  285. echo "${FMT_YELLOW}Found ~/.zshrc.${FMT_RESET} ${FMT_GREEN}Backing up to ${OLD_ZSHRC}${FMT_RESET}"
  286. mv ~/.zshrc "$OLD_ZSHRC"
  287. fi
  288. echo "${FMT_GREEN}Using the Oh My Zsh template file and adding it to ~/.zshrc.${FMT_RESET}"
  289. # Replace $HOME path with '$HOME' in $ZSH variable in .zshrc file
  290. omz=$(echo "$ZSH" | sed "s|^$HOME/|\$HOME/|")
  291. sed "s|^export ZSH=.*$|export ZSH=\"${omz}\"|" "$ZSH/templates/zshrc.zsh-template" > ~/.zshrc-omztemp
  292. mv -f ~/.zshrc-omztemp ~/.zshrc
  293. echo
  294. }
  295. setup_shell() {
  296. # Skip setup if the user wants or stdin is closed (not running interactively).
  297. if [ "$CHSH" = no ]; then
  298. return
  299. fi
  300. # If this user's login shell is already "zsh", do not attempt to switch.
  301. if [ "$(basename -- "$SHELL")" = "zsh" ]; then
  302. return
  303. fi
  304. # If this platform doesn't provide a "chsh" command, bail out.
  305. if ! command_exists chsh; then
  306. cat <<EOF
  307. I can't change your shell automatically because this system does not have chsh.
  308. ${FMT_BLUE}Please manually change your default shell to zsh${FMT_RESET}
  309. EOF
  310. return
  311. fi
  312. echo "${FMT_BLUE}Time to change your default shell to zsh:${FMT_RESET}"
  313. # Prompt for user choice on changing the default login shell
  314. printf '%sDo you want to change your default shell to zsh? [Y/n]%s ' \
  315. "$FMT_YELLOW" "$FMT_RESET"
  316. read -r opt
  317. case $opt in
  318. y*|Y*|"") ;;
  319. n*|N*) echo "Shell change skipped."; return ;;
  320. *) echo "Invalid choice. Shell change skipped."; return ;;
  321. esac
  322. # Check if we're running on Termux
  323. case "$PREFIX" in
  324. *com.termux*) termux=true; zsh=zsh ;;
  325. *) termux=false ;;
  326. esac
  327. if [ "$termux" != true ]; then
  328. # Test for the right location of the "shells" file
  329. if [ -f /etc/shells ]; then
  330. shells_file=/etc/shells
  331. elif [ -f /usr/share/defaults/etc/shells ]; then # Solus OS
  332. shells_file=/usr/share/defaults/etc/shells
  333. else
  334. fmt_error "could not find /etc/shells file. Change your default shell manually."
  335. return
  336. fi
  337. # Get the path to the right zsh binary
  338. # 1. Use the most preceding one based on $PATH, then check that it's in the shells file
  339. # 2. If that fails, get a zsh path from the shells file, then check it actually exists
  340. if ! zsh=$(command -v zsh) || ! grep -qx "$zsh" "$shells_file"; then
  341. if ! zsh=$(grep '^/.*/zsh$' "$shells_file" | tail -n 1) || [ ! -f "$zsh" ]; then
  342. fmt_error "no zsh binary found or not present in '$shells_file'"
  343. fmt_error "change your default shell manually."
  344. return
  345. fi
  346. fi
  347. fi
  348. # We're going to change the default shell, so back up the current one
  349. if [ -n "$SHELL" ]; then
  350. echo "$SHELL" > ~/.shell.pre-oh-my-zsh
  351. else
  352. grep "^$USER:" /etc/passwd | awk -F: '{print $7}' > ~/.shell.pre-oh-my-zsh
  353. fi
  354. echo "Changing your shell to $zsh..."
  355. # Check if user has sudo privileges to run `chsh` with or without `sudo`
  356. #
  357. # This allows the call to succeed without password on systems where the
  358. # user does not have a password but does have sudo privileges, like in
  359. # Google Cloud Shell.
  360. #
  361. # On systems that don't have a user with passwordless sudo, the user will
  362. # be prompted for the password either way, so this shouldn't cause any issues.
  363. #
  364. if user_can_sudo; then
  365. sudo -k chsh -s "$zsh" "$USER" # -k forces the password prompt
  366. else
  367. chsh -s "$zsh" "$USER" # run chsh normally
  368. fi
  369. # Check if the shell change was successful
  370. if [ $? -ne 0 ]; then
  371. fmt_error "chsh command unsuccessful. Change your default shell manually."
  372. else
  373. export SHELL="$zsh"
  374. echo "${FMT_GREEN}Shell successfully changed to '$zsh'.${FMT_RESET}"
  375. fi
  376. echo
  377. }
  378. # shellcheck disable=SC2183 # printf string has more %s than arguments ($FMT_RAINBOW expands to multiple arguments)
  379. print_success() {
  380. printf '%s %s__ %s %s %s %s %s__ %s\n' $FMT_RAINBOW $FMT_RESET
  381. printf '%s ____ %s/ /_ %s ____ ___ %s__ __ %s ____ %s_____%s/ /_ %s\n' $FMT_RAINBOW $FMT_RESET
  382. printf '%s / __ \\%s/ __ \\ %s / __ `__ \\%s/ / / / %s /_ / %s/ ___/%s __ \\ %s\n' $FMT_RAINBOW $FMT_RESET
  383. printf '%s/ /_/ /%s / / / %s / / / / / /%s /_/ / %s / /_%s(__ )%s / / / %s\n' $FMT_RAINBOW $FMT_RESET
  384. printf '%s\\____/%s_/ /_/ %s /_/ /_/ /_/%s\\__, / %s /___/%s____/%s_/ /_/ %s\n' $FMT_RAINBOW $FMT_RESET
  385. printf '%s %s %s %s /____/ %s %s %s %s....is now installed!%s\n' $FMT_RAINBOW $FMT_GREEN $FMT_RESET
  386. printf '\n'
  387. printf '\n'
  388. printf "%s %s %s\n" "Before you scream ${FMT_BOLD}${FMT_YELLOW}Oh My Zsh!${FMT_RESET} look over the" \
  389. "$(fmt_code "$(fmt_link ".zshrc" "file://$HOME/.zshrc" --text)")" \
  390. "file to select plugins, themes, and options."
  391. printf '\n'
  392. printf '%s\n' "• Follow us on Twitter: $(fmt_link @ohmyzsh https://twitter.com/ohmyzsh)"
  393. printf '%s\n' "• Join our Discord community: $(fmt_link "Discord server" https://discord.gg/ohmyzsh)"
  394. printf '%s\n' "• Get stickers, t-shirts, coffee mugs and more: $(fmt_link "Planet Argon Shop" https://shop.planetargon.com/collections/oh-my-zsh)"
  395. printf '%s\n' $FMT_RESET
  396. }
  397. main() {
  398. # Run as unattended if stdin is not a tty
  399. if [ ! -t 0 ]; then
  400. RUNZSH=no
  401. CHSH=no
  402. fi
  403. # Parse arguments
  404. while [ $# -gt 0 ]; do
  405. case $1 in
  406. --unattended) RUNZSH=no; CHSH=no ;;
  407. --skip-chsh) CHSH=no ;;
  408. --keep-zshrc) KEEP_ZSHRC=yes ;;
  409. esac
  410. shift
  411. done
  412. setup_color
  413. if ! command_exists zsh; then
  414. echo "${FMT_YELLOW}Zsh is not installed.${FMT_RESET} Please install zsh first."
  415. exit 1
  416. fi
  417. if [ -d "$ZSH" ]; then
  418. echo "${FMT_YELLOW}The \$ZSH folder already exists ($ZSH).${FMT_RESET}"
  419. if [ "$custom_zsh" = yes ]; then
  420. cat <<EOF
  421. You ran the installer with the \$ZSH setting or the \$ZSH variable is
  422. exported. You have 3 options:
  423. 1. Unset the ZSH variable when calling the installer:
  424. $(fmt_code "ZSH= sh install.sh")
  425. 2. Install Oh My Zsh to a directory that doesn't exist yet:
  426. $(fmt_code "ZSH=path/to/new/ohmyzsh/folder sh install.sh")
  427. 3. (Caution) If the folder doesn't contain important information,
  428. you can just remove it with $(fmt_code "rm -r $ZSH")
  429. EOF
  430. else
  431. echo "You'll need to remove it if you want to reinstall."
  432. fi
  433. exit 1
  434. fi
  435. setup_ohmyzsh
  436. setup_zshrc
  437. setup_shell
  438. print_success
  439. if [ $RUNZSH = no ]; then
  440. echo "${FMT_YELLOW}Run zsh to try it out.${FMT_RESET}"
  441. exit
  442. fi
  443. exec zsh -l
  444. }
  445. main "$@"